<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.1" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
xmlns:eg="http://examplotron.org/0/" 
xmlns:saxon="http://icl.com/saxon" 
xmlns:xlink="http://www.w3.org/1999/xlink" 
exclude-result-prefixes="saxon xlink eg" extension-element-prefixes="saxon">

<!---
Modified for the B2B XML Generator

Version 1

Steven Hadley
-->

	<xsl:output method="html" version="1.0"  indent="yes"/>
	<!-- Get the list of namespaces in the instance document -->
	<xsl:variable name="ns-rtf1">
		<namespaces>
			<xsl:call-template name="getNs"/>
		</namespaces>
	</xsl:variable>
	<xsl:variable name="ns-rtf">
		<namespaces>
			<xsl:for-each select="saxon:distinct(saxon:node-set($ns-rtf1)/namespaces/ns/@uri)">
				<ns orig-prefix="{../@orig-prefix}" uri="{.}"/>
			</xsl:for-each>
		</namespaces>
	</xsl:variable>
	

	<xsl:variable name="ns" select="saxon:node-set($ns-rtf)"/>
	
	<xsl:variable name="anon-ns">
		<xsl:variable name="temp">
		<xsl:for-each select="saxon:distinct(//*|//@*)">
			<xsl:if test="string-length(substring-before(name(),':')) = 0">
				<xsl:text>1</xsl:text>
			</xsl:if>
		</xsl:for-each>
		</xsl:variable>
		<xsl:choose>
		<xsl:when test="$temp = 1">
			<xsl:text>1</xsl:text>
		</xsl:when>
		<xsl:otherwise>
			<xsl:text>0</xsl:text>
		</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>

	<xsl:template name="getNs">
		<xsl:for-each select="//*">
			<xsl:choose>
			<xsl:when test="string-length(substring-before(name(),':')) = 0">
				<ns orig-prefix="anon" uri="{namespace-uri()}"/>
			</xsl:when>
			<xsl:otherwise>
				<ns orig-prefix="{substring-before(name(),':')}" uri="{namespace-uri()}"/>
			</xsl:otherwise>
			</xsl:choose>
		</xsl:for-each>
		<xsl:for-each select="//eg:import">
			<xsl:for-each select="document(@xlink:href)">
				<xsl:call-template name="getNs"/>
			</xsl:for-each>
		</xsl:for-each>
		<xsl:for-each select="//eg:include">
			<xsl:for-each select="document(@xlink:href)">
				<xsl:call-template name="getNs"/>
			</xsl:for-each>
		</xsl:for-each>
	</xsl:template>

	<!--returns namespaces for java ONLY as it includes \ escape characters-->
	<xsl:template match="ns" mode="ns-java">
		<xsl:variable name="uri" select="@uri"/>
		<xsl:choose>
		<xsl:when test="string-length($uri)=0">		
		</xsl:when>
		<xsl:otherwise>
			<!---we don't output the examplotron namspace references-->
			<xsl:if test="not(@orig-prefix = 'eg')">
				<!---output xmlns:?"uri"-->
				<font class="xmlnsText">
				<xsl:text>xmlns:</xsl:text><xsl:value-of select="@orig-prefix"/><xsl:text>=\"</xsl:text><xsl:value-of select="@uri"/><xsl:text>\" </xsl:text>
				</font>
			</xsl:if>	
		</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	<!--returns namespaces as text-->
	<xsl:template match="ns" mode="ns">
		<xsl:variable name="uri" select="@uri"/>
		<xsl:choose>
		<xsl:when test="string-length($uri)=0">		
		</xsl:when>
		<xsl:otherwise>
			<!---we don't output the examplotron namspace references-->
			<xsl:if test="not(@orig-prefix = 'eg')">
				<!---output xmlns:?"uri"-->
				<font class="xmlnsText">
				<xsl:text>xmlns:</xsl:text><xsl:value-of select="@orig-prefix"/><xsl:text>="</xsl:text><xsl:value-of select="@uri"/><xsl:text>" </xsl:text>
				</font><br/>
			</xsl:if>
		</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	<!---<xsl:template match="/">
			call this from in my html generator file
			<xsl:apply-templates select="$ns/namespaces/ns" mode="ns"/>
	</xsl:template>-->

</xsl:stylesheet><!-- Stylus Studio meta-information - (c)1998-2002 eXcelon Corp.
<metaInformation>
<scenarios/><MapperInfo srcSchemaPath="" srcSchemaRoot="" srcSchemaPathIsRelative="yes" srcSchemaInterpretAsXML="no" destSchemaPath="" destSchemaRoot="" destSchemaPathIsRelative="yes" destSchemaInterpretAsXML="no"/>
</metaInformation>
-->